/*********************************************************************
 *
 * Authors: Vincenzo Ciaschini - Vincenzo.Ciaschini@cnaf.infn.it 
 *
 * Copyright (c) 2002, 2003 INFN-CNAF on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or
 * http://www.edg.org/license.html
 *
 * Parts of this code may be based upon or even include verbatim pieces,
 * originally written by other people, in which case the original header
 * follows.
 *
 *********************************************************************/

#ifndef _API_UTIL_H
#define _API_UTIL_H

#include <netdb.h>
#include <string>
#include <dirent.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "globus_config.h"
#include "gssapi.h"
#include "globus_gss_assist.h"

#include <stdio.h>
#include <openssl/x509.h>
#include <openssl/asn1.h>

#include "newca.h"

#if 0
#include "GSISocketClient.h"
#include "GSISocketAgent.h"
#else
#include "Client.h"
#endif

#include "voms_api.h"

#include <iostream>
#include <iomanip>

#include <openssl/pem.h>
#include <openssl/asn1.h>
#include <openssl/evp.h>
#include <openssl/bio.h>
#include <openssl/err.h>
#include <openssl/x509.h>
#include <openssl/x509v3.h>
#include <openssl/e_os.h>

#include "sign.h"

static bool parse(std::string &is, const std::string s);
static bool parse(std::string &is, const std::string s, int &val);
static bool parse(std::string &is, const std::string s, std::string &val);

struct ext_voms {
  struct voms voms;
  int datalen;
  std::string real_data;
  std::string extra_data;
  std::string signed_data;
};

static bool parse_rest(int len, std::string &data, struct voms &voms, verror_type &error);
static bool unformat(const std::string data, struct ext_voms &results, verror_type &error);
static bool check(ext_voms &voms, verror_type &error, std::string &vdir, std::string &cdir);
static bool check_cert(X509 *cert, verror_type &error, std::string &cdir);
static int MS_CALLBACK cb(int ok, X509_STORE_CTX *ctx);
static bool id_data(std::string &subj, std::string &ca, verror_type &error);
static char *get_globusid(gss_cred_id_t handle);
extern bool contact(const std::string &hostname, int port, const std::string &contact,
		    const std::string &command, std::string &buffer, std::string &subject, std::string &ca, verror_type &error);
extern bool retrieve(X509 *cert, STACK_OF(X509) *chain, recurse_type how, 
		     std::string &buffer, std::string &vo, std::string &file, std::string &subject, std::string &ca, verror_type &error);
extern bool verify(std::string message, vomsdata &voms, verror_type &error, std::string vdir, std::string cdir, std::string subject, std::string ca,bool verify = true);

#endif
